/*
* Copyright (C) 2003-2007 Funambol
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#pragma once
#include "afxwin.h"
#include "OutlookPluginDoc.h"
#include "CustomGroupbox.h"

class CAccountSettings : public CFormView
{
	DECLARE_DYNCREATE(CAccountSettings)
protected:
    CAccountSettings();           // protected constructor used by dynamic creation
    virtual ~CAccountSettings();
public:
    enum { IDD = IDD_ACCOUNT };
    COutlookPluginDoc* GetDocument();
#ifdef _DEBUG
    virtual void AssertValid() const;
#ifndef _WIN32_WCE
    virtual void Dump(CDumpContext& dc) const;
#endif
#endif

protected:
   virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support  
   virtual BOOL PreTranslateMessage(MSG* pMsg);
   DECLARE_MESSAGE_MAP()
public:   
    CEdit editUrl;
    CEdit editUser;
    CEdit editPassword;
    CButton butProxy;
    CBrush  brushHollow;
    bool keepSettings;

    bool saveSettings(bool saveToDisk);   

    afx_msg void OnBnClickedAccountButCancel();
    afx_msg void OnBnClickedAccountButOk();
    afx_msg LRESULT OnInitForm(WPARAM, LPARAM);
    afx_msg int OnCreate(LPCREATESTRUCT lpcs);
    afx_msg void OnNcPaint();
    afx_msg void OnBnClickedAccountButProxy();
    CCustomGroupbox groupServer;
    afx_msg HBRUSH OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor);
    afx_msg void OnDestroy();
};


