/*
* Copyright (C) 2003-2007 Funambol
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#pragma once

#define ANIM_ICON_ARROWS 501
#define ANIM_ICON_DELAY 300
#define COLOR_INT_PANE RGB(241,241,241)
//#define COLOR_EXT_PANE RGB(230,230,230)
#define COLOR_EXT_PANE RGB(255,255,255)

enum ANIM_ICON_STATE {STATE_ARROWS, STATE_INVISIBLE, STATE_ICON_SYNC, STATE_DONE, STATE_BUTTON};

class CAnimatedIcon : public CStatic
{
	DECLARE_DYNAMIC(CAnimatedIcon)

public:
    int state;
    int counterAnim;
    bool bMouseCaptured;
    CBrush brushHollow;
    CBitmap bmpBkDark;
	CAnimatedIcon();  
    void Animate();
    void StopAnim();
	virtual ~CAnimatedIcon();

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	DECLARE_MESSAGE_MAP()

    afx_msg void OnTimer( UINT_PTR nIDEvent );
    afx_msg BOOL OnEraseBkgnd(CDC* pDC);
    afx_msg void OnPaint( );
    afx_msg void OnMouseMove(UINT nFlags, CPoint point);
    afx_msg LRESULT OnMouseLeave(WPARAM, LPARAM);
};
