/*
* Copyright (C) 2003-2007 Funambol
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


// CustomLabel.cpp : implementation file
//

#include "stdafx.h"
#include "OutlookPlugin.h"
#include "CustomLabel.h"

IMPLEMENT_DYNAMIC(CCustomLabel, CStatic)

CCustomLabel::CCustomLabel()
	: CStatic()
{
    brush.CreateSolidBrush(COLOR_BRUSH);
    bMouseCaptured = false;
    clrLinkText = COLOR_LINK_NORMAL;
}

CCustomLabel::~CCustomLabel()
{
}

void CCustomLabel::DoDataExchange(CDataExchange* pDX)
{
	CStatic::DoDataExchange(pDX);
}


BEGIN_MESSAGE_MAP(CCustomLabel, CStatic)
    ON_WM_CTLCOLOR()
    ON_WM_MOUSEMOVE()
    ON_MESSAGE(WM_MOUSELEAVE, OnMouseLeave)
END_MESSAGE_MAP()


// CCustomLabel message handlers

void CCustomLabel::OnPaint(){
    CStatic::OnPaint();
}

HBRUSH CCustomLabel::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor){
  HBRUSH hbr = CStatic::OnCtlColor(pDC, pWnd, nCtlColor);

  hbr = (HBRUSH) brush.GetSafeHandle();
   
  return hbr;
}

void CCustomLabel::OnMouseMove(UINT nFlags, CPoint point ){
    if(! bMouseCaptured){
        TRACKMOUSEEVENT Tme;
        Tme.cbSize = sizeof(TRACKMOUSEEVENT);
        Tme.dwFlags = TME_LEAVE;
        Tme.hwndTrack = m_hWnd;
        int Result = TrackMouseEvent(&Tme); 

        clrLinkText = COLOR_LINK_HOVER;
        SetFont(&fontHover);
        bMouseCaptured = true;
        Invalidate();
    };    
    CStatic::OnMouseMove(nFlags, point);
}

LRESULT CCustomLabel::OnMouseLeave(WPARAM wParam, LPARAM lParam){
    bMouseCaptured = false;
    clrLinkText = COLOR_LINK_NORMAL;
    SetFont(&fontNormal);
    Invalidate();
    return 0;
}

void CCustomLabel::init(){
    LOGFONT lf;
    memset(&lf, 0, sizeof(LOGFONT));      
    GetFont()->GetLogFont(&lf);
    lf.lfWeight = FW_BOLD; lf.lfUnderline = TRUE;
    VERIFY(fontNormal.CreateFontIndirect(&lf));  

    VERIFY(fontHover.CreateFontIndirect(&lf));  

    SetFont(&fontNormal);
    
}